﻿using System;

using Template.Buildings;

namespace Template.Commands
{
    public class PowerDownBuilding : ICommand
    {
        private IBuilding _building;

        public PowerDownBuilding(IBuilding building)
        {
            _building = building;
        }

        public void Execute()
        {
            Console.WriteLine("Building got powered down!");
            _building.ConsumesPower = false;
        }

        public void Undo()
        {
            Console.WriteLine("Building got powered up!");
            _building.ConsumesPower = true;
        }
    }
}
