﻿using System;

using Template.Units;
using Template.Shooting;
using Template.Armor;

namespace Template.FactionInfo.NOD
{
    public class NodDetails : FactionDetailsFactory
    {
        public override UnitSide GetSide()
        {
            return UnitSide.NOD;
        }

        public override UnitBehaviour GetBehaviour()
        {
            return UnitBehaviour.Aggressive;
        }

        public override string GetDescription(UnitType unitType)
        {
            switch (unitType)
            {
                case UnitType.Soldier: return "Soldier";
                case UnitType.Engineer: return "Engineer";
                case UnitType.EliteUnit: return "Cyborg Commando";
                default: return null;
            }
        }

        public override IShootingBehaviour GetShootingBehaviour(UnitType unitType)
        {
            switch (unitType)
            {
                case UnitType.Soldier: return new NormalShot();
                case UnitType.Engineer: return new CantShoot();
                case UnitType.EliteUnit: return new RailGun();
                default: return null;
            }
        }

        public override IArmorBehaviour GetArmor(UnitType unitType)
        {
            switch (unitType)
            {
                case UnitType.Soldier: return new KevlarArmor();
                case UnitType.Engineer: return new NoArmor();
                case UnitType.EliteUnit: return new CyberArmor();
                default: return null;
            }
        }
    }
}
